{
  open Parser        (* Le type token est dfini dans parser.mli *)
}

rule token = parse
  | [' ''\t''\n']	{ token lexbuf }
  | ['0'-'9']+		{ INT (int_of_string (Lexing.lexeme lexbuf)) }
  | "true"		{ BOOL true }
  | "false"		{ BOOL false }
  | "if"		{ IF }
  | "then"		{ THEN }
  | "else"		{ ELSE }
  | '+'			{ PLUS }
  | '-'			{ MINUS }
  | '*'			{ TIMES }
  | '/'			{ DIV }
  | '('			{ LPAREN }
  | ')'			{ RPAREN }
  | '>'			{ GT }
  | "not"		{ NOT }
  | "&&"		{ AND }
  | "let"		{ LET }
  | "rec"		{ REC }
  | "in"		{ IN }
  | "end"		{ END }
  | "fun"		{ FUN }
  | "="			{ EQ }
  | "=="		{ EQEQ }
  | ";;"		{ SCSC }
  | "->"		{ ARROW }
  | ['a'-'z''_']+['a'-'z''A'-'Z''0'-'9''_''\'']*
			{ ID (Lexing.lexeme lexbuf) }
  | eof			{ EOF }
